=== kthxbye/CMakeLists.txt ===
install (CODE
	"message (STATUS \"\")
	message (STATUS \" **************************************\")
	message (STATUS \" * Kadu is now successfully installed *\")
	message (STATUS \" **************************************\")
	message (STATUS \"\")
	message (STATUS \" Thanks for choosing Kadu Communicator and ENJOY!!!\")
	message (STATUS \"\")
	message (STATUS \"                                  Kadu Team\")
	message (STATUS \"\")"
)
