=== debian/changelog ===
kadu (3.0~rc1-1) unstable; urgency=medium

  * New upstream release
  * Added libqxmpp-dev to Build-Depends
  * Removed debian/patches/04-int_narrowing_fix.patch. Issue fixed
    upstream.

 -- Patryk Cisek <patryk@debian.org>  Fri, 25 Dec 2015 18:07:46 +0100

kadu (2.1-2) unstable; urgency=medium

  * Added debian/patches/04-int_narrowing_fix.patch (Closes: #795488)
  * Added description and author to 03-exclude_unsupported_plugins.patch

 -- Patryk Cisek <patryk@debian.org>  Sat, 17 Oct 2015 14:57:17 +0200

kadu (2.1-1) unstable; urgency=medium

  * New upstream release (Closes: #795488)
  * Updated debian/patches/02-about-dialog.patch for Kadu 2.1
  * Removed 03-exclude_unsupported_plugins.patch, as it's been applied
    upstream.
  * Removed kadu.menu, as there's a corresponding .desktop file in
    place.
  * Removed obsolete url from debian/watch

 -- Patryk Cisek <patryk@debian.org>  Sun, 11 Oct 2015 12:55:38 +0200
