=== debian/watch ===
version=3

opts="uversionmangle=s/-(alpha|beta|rc)/~$1/" \
http://www.kadu.net/download/stable/kadu-(.*)\.tar\.bz2
