## kadu 3.0

=== debian/changelog ===
kadu (3.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop all QT4 and no needed depends. (Closes: #784472, #808697)
  * Update description for QT5.
  * Use secured links for VCS.
  * Enable parallel building. (Closes: #821275)
  * Bump Standards-Version to 3.9.8.
  * Fix watch file.

 -- Mateusz Łukasik <mati75@linuxmint.pl>  Wed, 15 Jun 2016 20:12:26 +0200

kadu (3.0-1) unstable; urgency=medium

  * New upstream release
  * Bumped Standards-Version

 -- Patryk Cisek <patryk@debian.org>  Fri, 15 Apr 2016 10:04:09 +0200

kadu (3.0~rc1-1.1) unstable; urgency=medium

  * Non-maintainer upload with maintainer's permission.
  * Drop build-dependency on libindicate-qt-dev. (Closes: #812240)

 -- Felix Geyer <fgeyer@debian.org>  Wed, 23 Mar 2016 18:23:11 +0100
